Index: fromcwd.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/fromcwd.cc,v
retrieving revision 2.10
diff -u -p -r2.10 fromcwd.cc
--- fromcwd.cc	2001/11/05 13:00:36	2.10
+++ fromcwd.cc	2001/11/11 06:54:55
@@ -26,7 +26,8 @@
    that we search recursively. */
 
 #if 0
-static const char *cvsid = "\n%%% $Id: fromcwd.cc,v 2.10 2001/11/05 13:00:36 rbcollins Exp $\n";
+static const char *cvsid =
+  "\n%%% $Id: fromcwd.cc,v 2.10 2001/11/05 13:00:36 rbcollins Exp $\n";
 #endif
 
 #include "win32.h"
@@ -53,7 +54,7 @@ static int
 is_test_version (char *v)
 {
   int i;
-  for (i=0; v[i] && isdigit (v[i]); i++) ;
+  for (i = 0; v[i] && isdigit (v[i]); i++);
   return (i >= 6) ? 1 : 0;
 }
 
@@ -62,19 +63,19 @@ canonicalize_version (const char *v)
 {
   static char nv[3][100];
   static int idx = 0;
-  char *np ;
+  char *np;
   const char *dp;
   int i;
 
-  idx = (idx+1) % 3;
+  idx = (idx + 1) % 3;
   np = nv[idx];
 
   while (*v)
     {
       if (isdigit (*v))
 	{
-	  for (dp=v; *dp && isdigit (*dp); dp++) ;
-	  for (i=dp-v; i<12; i++)
+	  for (dp = v; *dp && isdigit (*dp); dp++);
+	  for (i = dp - v; i < 12; i++)
 	    *np++ = '0';
 	  while (v < dp)
 	    *np++ = *v++;
@@ -106,7 +107,7 @@ found_file (char *path, unsigned int fsi
       }
 
   if (p == NULL)
-      p = new_package (f.pkg);
+    p = new_package (f.pkg);
 
   int trust = is_test_version (f.ver) ? TRUST_TEST : TRUST_CURR;
 
@@ -120,11 +121,11 @@ found_file (char *path, unsigned int fsi
     }
 
   if (p->info[trust].version)
-    free(p->info[trust].version);
+    free (p->info[trust].version);
   p->info[trust].version = _strdup (f.ver);
 
   if (p->info[trust].install)
-    free(p->info[trust].install);
+    free (p->info[trust].install);
   p->info[trust].install = _strdup (path);
 
   p->info[trust].install_size = fsize;
@@ -150,7 +151,7 @@ do_fromcwd (HINSTANCE h)
   char srcpath[_MAX_PATH];
   for (i = 0; i < npackages; i++)
     {
-      p = package+i;
+      p = package + i;
       for (t = TRUST_PREV; t <= TRUST_TEST; t++)
 	if (p->info[t].install)
 	  {
@@ -168,7 +169,7 @@ do_fromcwd (HINSTANCE h)
 	      }
 	    if (h != INVALID_HANDLE_VALUE)
 	      {
-		msg("-- got it");
+		msg ("-- got it");
 		FindClose (h);
 		p->info[t].source = _strdup (srcpath);
 		p->info[t].source_size = wfd.nFileSizeLow;
Index: geturl.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/geturl.cc,v
retrieving revision 2.11
diff -u -p -r2.11 geturl.cc
--- geturl.cc	2001/11/07 00:09:04	2.11
+++ geturl.cc	2001/11/11 06:54:55
@@ -17,7 +17,10 @@
    netio.cc.  We add a progress dialog and some convenience functions
    (like collect to string or file */
 
-static char *cvsid = "\n%%% $Id: geturl.cc,v 2.11 2001/11/07 00:09:04 rbcollins Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: geturl.cc,v 2.10 2001/11/02 00:50:19 rbcollins Exp $\n";
+#endif
 
 #include "win32.h"
 #include "commctrl.h"
@@ -60,13 +63,12 @@ dialog_cmd (HWND h, int id, HWND hwndctl
     case IDCANCEL:
       exit_setup (0);
     }
+  return 0;
 }
 
 static BOOL CALLBACK
 dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
 {
-  int i, j;
-  HWND listbox;
   switch (message)
     {
     case WM_INITDIALOG:
@@ -90,16 +92,18 @@ dialog_proc (HWND h, UINT message, WPARA
 static WINAPI DWORD
 dialog (void *)
 {
-  int rv = 0;
   MSG m;
-  HWND local_gw_dialog = CreateDialog (hinstance, MAKEINTRESOURCE (IDD_DLSTATUS),
-				   0, dialog_proc);
+  HWND local_gw_dialog =
+    CreateDialog (hinstance, MAKEINTRESOURCE (IDD_DLSTATUS),
+		  0, dialog_proc);
   ShowWindow (local_gw_dialog, SW_SHOWNORMAL);
   UpdateWindow (local_gw_dialog);
-  while (GetMessage (&m, 0, 0, 0) > 0) {
-    TranslateMessage (&m);
-    DispatchMessage (&m);
-  }
+  while (GetMessage (&m, 0, 0, 0) > 0)
+    {
+      TranslateMessage (&m);
+      DispatchMessage (&m);
+    }
+  return 0;
 }
 
 static DWORD start_tics;
@@ -121,16 +125,16 @@ init_dialog (char *url, int length)
       SendMessage (gw_pprogress, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
       SendMessage (gw_iprogress, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
     }
-  char *sl=url, *cp;
-  for (cp=url; *cp; cp++)
+  char *sl = url, *cp;
+  for (cp = url; *cp; cp++)
     if (*cp == '/' || *cp == '\\' || *cp == ':')
-      sl = cp+1;
+      sl = cp + 1;
   max_bytes = length;
   SetWindowText (gw_url, sl);
   SetWindowText (gw_rate, "Connecting...");
   SendMessage (gw_progress, PBM_SETPOS, (WPARAM) 0, 0);
   ShowWindow (gw_progress, (length > 0) ? SW_SHOW : SW_HIDE);
-  if (length > 0 )
+  if (length > 0)
     SetWindowText (gw_progress_text, "Package");
   else
     SetWindowText (gw_progress_text, "       ");
@@ -160,9 +164,9 @@ progress (int bytes)
   int kbps;
   static unsigned int last_tics = 0;
   DWORD tics = GetTickCount ();
-  if (tics == start_tics) // to prevent division by zero
+  if (tics == start_tics)	// to prevent division by zero
     return;
-  if (tics < last_tics + 200) // to prevent flickering updates
+  if (tics < last_tics + 200)	// to prevent flickering updates
     return;
   last_tics = tics;
 
@@ -175,13 +179,14 @@ progress (int bytes)
       int perc = bytes / (max_bytes / 100);
       SendMessage (gw_progress, PBM_SETPOS, (WPARAM) perc, 0);
       sprintf (buf, "%3d %%  (%dk/%dk)  %d kb/s\n",
-	       perc, bytes/1000, max_bytes/1000, kbps);
+	       perc, bytes / 1000, max_bytes / 1000, kbps);
       if (total_download_bytes > 0)
-        {
-          int totalperc = (total_download_bytes_sofar + bytes) / (
-                    total_download_bytes / 100);
-          SendMessage (gw_pprogress, PBM_SETPOS, (WPARAM) totalperc, 0);
-        }
+	{
+	  int totalperc =
+	    (total_download_bytes_sofar +
+	     bytes) / (total_download_bytes / 100);
+	  SendMessage (gw_pprogress, PBM_SETPOS, (WPARAM) totalperc, 0);
+	}
     }
   else
     sprintf (buf, "%d  %d kb/s\n", bytes, kbps);
@@ -189,7 +194,8 @@ progress (int bytes)
   SetWindowText (gw_rate, buf);
 }
 
-struct GUBuf {
+struct GUBuf
+{
   GUBuf *next;
   int count;
   char buf[2000];
@@ -214,7 +220,7 @@ get_url_to_string (char *_url)
 
   GUBuf *bufs = 0;
   GUBuf **nextp = &bufs;
-  int total_bytes = 1; /* for the NUL */
+  int total_bytes = 1;		/* for the NUL */
   progress (0);
   while (1)
     {
@@ -265,7 +271,7 @@ get_url_to_file (char *_url, char *_file
     }
   init_dialog (_url, expected_length);
 
-  remove (_filename); /* but ignore errors */
+  remove (_filename);		/* but ignore errors */
 
   NetIO *n = NetIO::open (_url, allow_ftp_auth);
   if (!n || !n->ok ())
@@ -278,7 +284,7 @@ get_url_to_file (char *_url, char *_file
   FILE *f = fopen (_filename, "wb");
   if (!f)
     {
-      char *err = strerror (errno);
+      const char *err = strerror (errno);
       if (!err)
 	err = "(unknown error)";
       fatal (IDS_ERR_OPEN_WRITE, _filename, err);
Index: hash.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/hash.cc,v
retrieving revision 2.2
diff -u -p -r2.2 hash.cc
--- hash.cc	2000/08/30 01:07:51	2.2
+++ hash.cc	2001/11/11 06:54:55
@@ -15,14 +15,18 @@
 
 /* Simple hash class for install.cc */
 
-static char *cvsid = "\n%%% $Id: hash.cc,v 2.2 2000/08/30 01:07:51 dj Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: hash.cc,v 2.2 2000/08/30 01:07:51 dj Exp $\n";
+#endif
 
 #include <stdlib.h>
 #include <string.h>
 
 #include "hash.h"
 
-class hash_internals {
+class hash_internals
+{
 public:
   char **keys;
   int numkeys;
@@ -50,7 +54,7 @@ void
 hash::add (char *string)
 {
   int i;
-  for (i=0; i<h->numkeys; i++)
+  for (i = 0; i < h->numkeys; i++)
     if (strcmp (h->keys[i], string) == 0)
       return;
   if (h->numkeys >= h->maxkeys)
@@ -60,7 +64,7 @@ hash::add (char *string)
     }
 
   h->keys[h->numkeys] = _strdup (string);
-  h->numkeys ++;
+  h->numkeys++;
 }
 
 
@@ -68,7 +72,7 @@ int
 hash::has (char *string)
 {
   int i;
-  for (i=0; i<h->numkeys; i++)
+  for (i = 0; i < h->numkeys; i++)
     if (strcmp (h->keys[i], string) == 0)
       return 1;
   return 0;
@@ -79,7 +83,7 @@ hash::enumerate (char *prev)
 {
   if (prev == 0)
     h->prev_index = -1;
-  h->prev_index ++;
+  h->prev_index++;
   if (h->prev_index >= h->numkeys)
     return 0;
   return h->keys[h->prev_index];
@@ -88,8 +92,8 @@ hash::enumerate (char *prev)
 static int
 rev_len (const void *va, const void *vb)
 {
-  char *a = *(char **)va;
-  char *b = *(char **)vb;
+  char *a = *(char **) va;
+  char *b = *(char **) vb;
   return strcmp (b, a);
 }
 
Index: hash.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/hash.h,v
retrieving revision 2.1
diff -u -p -r2.1 hash.h
--- hash.h	2000/08/30 01:05:42	2.1
+++ hash.h	2001/11/11 06:54:55
@@ -17,11 +17,12 @@
 
 class hash_internals;
 
-class hash {
+class hash
+{
   hash_internals *h;
- public:
-  hash ();
-  ~hash ();
+public:
+    hash ();
+   ~hash ();
 
   void add (char *string);
   int has (char *string);
@@ -30,5 +31,5 @@ class hash {
   void add_subdirs (char *path);
   void reverse_sort ();
 
-  char *enumerate (char *prev=0);
+  char *enumerate (char *prev = 0);
 };
Index: ini.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/ini.cc,v
retrieving revision 2.9
diff -u -p -r2.9 ini.cc
--- ini.cc	2001/06/13 16:11:01	2.9
+++ ini.cc	2001/11/11 06:54:55
@@ -18,7 +18,10 @@
    flex parsers are provided also.  We check to see if this setup.ini
    is older than the one we used last time, and if so, warn the user. */
 
-static char *cvsid = "\n%%% $Id: ini.cc,v 2.9 2001/06/13 16:11:01 cgf Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: ini.cc,v 2.9 2001/06/13 16:11:01 cgf Exp $\n";
+#endif
 
 #include "win32.h"
 
@@ -33,11 +36,12 @@ static char *cvsid = "\n%%% $Id: ini.cc,
 #include "geturl.h"
 #include "dialog.h"
 #include "msg.h"
-#include "mkdir.h"
 #include "log.h"
 #include "version.h"
 #include "mount.h"
 
+#include "io_stream.h"
+
 unsigned int setup_timestamp = 0;
 char *setup_version = 0;
 
@@ -68,7 +72,7 @@ do_ini (HINSTANCE h)
   ini_init (ini_file);
 
   setup_timestamp = 0;
-  /*yydebug = 1;*/
+  /*yydebug = 1; */
 
   if (yyparse () || error_count > 0)
     {
@@ -80,24 +84,28 @@ do_ini (HINSTANCE h)
   else
     {
       /* save known-good setup.ini locally */
-      FILE *inif = fopen ("setup.ini", "wb");
-      if (inif)
+      io_stream *inistream = io_stream::open ("file://setup.ini", "wb");
+      if (inistream)
 	{
-	  fwrite (ini_file, 1, strlen (ini_file), inif);
-	  fclose (inif);
+	  inistream->write (ini_file, strlen (ini_file));
+	  delete inistream;
 	}
     }
 
   if (get_root_dir ())
     {
-      mkdir_p (1, cygpath ("/etc/setup", 0));
+      io_stream::mkpath_p (PATH_TO_DIR, "cygfile:///etc/setup");
 
       unsigned int old_timestamp = 0;
-      FILE *ots = fopen (cygpath ("/etc/setup/timestamp", 0), "rt");
+      io_stream *ots =
+	io_stream::open ("cygfile:///etc/setup/timestamp", "rt");
       if (ots)
 	{
-	  fscanf (ots, "%u", &old_timestamp);
-	  fclose (ots);
+	  char temp[20];
+	  memset (temp, '\0', 20);
+	  if (ots->read (temp, 19))
+	    sscanf (temp, "%u", &old_timestamp);
+	  delete ots;
 	  if (old_timestamp && setup_timestamp
 	      && (old_timestamp > setup_timestamp))
 	    {
@@ -108,16 +116,20 @@ do_ini (HINSTANCE h)
 	}
       if (setup_timestamp)
 	{
-	  FILE *nts = fopen (cygpath ("/etc/setup/timestamp", 0), "wt");
+	  io_stream *nts =
+	    io_stream::open ("cygfile:///etc/setup/timestamp", "wt");
 	  if (nts)
 	    {
-	      fprintf (nts, "%u", setup_timestamp);
-	      fclose (nts);
+	      char temp[20];
+	      sprintf (temp, "%u", setup_timestamp);
+	      nts->write (temp, strlen (temp));
+	      delete nts;
 	    }
 	}
     }
 
-  msg ("setup_version is %s, our_version is %s", setup_version?:"(null)", version);
+  msg ("setup_version is %s, our_version is %s", setup_version ? : "(null)",
+       version);
   if (setup_version)
     {
       char *ini_version = canonicalize_version (setup_version);
@@ -131,7 +143,8 @@ do_ini (HINSTANCE h)
 
 extern int yylineno;
 
-extern "C" int yyerror (char *s, ...)
+extern "C" int
+yyerror (char *s, ...)
 {
   char buf[1000];
   int len;
@@ -154,14 +167,16 @@ extern "C" int yyerror (char *s, ...)
       strcpy (error_buf, buf);
     }
   error_count++;
+  /* TODO: is return 0 correct? */
+  return 0;
 }
 
-extern "C" int fprintf (FILE *f, const char *s, ...);
+extern "C" int fprintf (FILE * f, const char *s, ...);
 
 static char stderrbuf[1000];
 
 int
-fprintf (FILE *f, const char *fmt, ...)
+fprintf (FILE * f, const char *fmt, ...)
 {
   char buf[1000];
   int rv;
@@ -174,7 +189,7 @@ fprintf (FILE *f, const char *fmt, ...)
       if (char *nl = strchr (stderrbuf, '\n'))
 	{
 	  *nl = 0;
-	  /*OutputDebugString (stderrbuf);*/
+	  /*OutputDebugString (stderrbuf); */
 	  MessageBox (0, buf, "Cygwin Setup", 0);
 	  stderrbuf[0] = 0;
 	}
Index: ini.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/ini.h,v
retrieving revision 2.19
diff -u -p -r2.19 ini.h
--- ini.h	2001/11/09 14:12:00	2.19
+++ ini.h	2001/11/11 06:54:56
@@ -41,14 +41,16 @@ typedef enum
   TRUST_CURR,
   TRUST_TEST,
   NTRUST
-} trusts;
+}
+trusts;
 
 typedef enum
 {
   EXCLUDE_NONE = 0,
   EXCLUDE_BY_SETUP,
   EXCLUDE_NOT_FOUND
-} excludes;
+}
+excludes;
 
 #define is_download_action(pkg) \
   ((pkg)->action == ACTION_PREV || \
@@ -75,55 +77,58 @@ typedef enum
 #define SRCACTION_YES		1
 typedef struct _Info
 {
-  char *version;	/* version part of filename */
-  char *install;	/* file name to install */
+  char *version;		/* version part of filename */
+  char *install;		/* file name to install */
   unsigned int install_size;	/* in bytes */
-  int install_exists;	/* install file exists on disk */
-  int derived;		/* True if we "figured out" that this version should
-			   go here but it was not in setup.ini */
-  char *source;		/* sources for installed binaries */
+  int install_exists;		/* install file exists on disk */
+  int derived;			/* True if we "figured out" that this version should
+				   go here but it was not in setup.ini */
+  char *source;			/* sources for installed binaries */
   unsigned int source_size;	/* in bytes */
-  int source_exists;	/* source file exists on disk */
+  int source_exists;		/* source file exists on disk */
 #ifdef __cplusplus
-  _Info (const char *_install, const char *_version,
-	 int _install_size, const char *_source = NULL,
-	 int _source_size = 0);
+    _Info (const char *_install, const char *_version,
+	   int _install_size, const char *_source = NULL,
+	   int _source_size = 0);
 #endif
-} Info;			/* +1 for TRUST_UNKNOWN */
+}
+Info;				/* +1 for TRUST_UNKNOWN */
 
 typedef struct _CategoryPackage
 {
-  struct _CategoryPackage *next;  /* The next package pointer in the list */
-  char *pkgname;		  /* This should be Package *, but the packages can move*/
-} CategoryPackage;
+  struct _CategoryPackage *next;	/* The next package pointer in the list */
+  char *pkgname;		/* This should be Package *, but the packages can move */
+}
+CategoryPackage;
 
 struct _Category
 {
-  struct _Category *next; /* the next category in the list */
-  char *name;		  /* the category */
-  CategoryPackage *packages; /* the packages in this category */
+  struct _Category *next;	/* the next category in the list */
+  char *name;			/* the category */
+  CategoryPackage *packages;	/* the packages in this category */
 };
 
 typedef struct _Dependency
 {
-  struct _Dependency *next; /* the next package in this dependency list */
-  char *package;	/* the name of the package that is depended on */
-} Dependency; 		/* Dependencies can be used for
-			   recommended/required/related... */
+  struct _Dependency *next;	/* the next package in this dependency list */
+  char *package;		/* the name of the package that is depended on */
+}
+Dependency;			/* Dependencies can be used for
+				   recommended/required/related... */
 struct _Package
 {
-  char *name;		/* package name, like "cygwin" */
-  char *sdesc;		/* short description (replaces "name" if provided) */
-  char *ldesc;		/* long description (multi-line) */
-  Category *category;   /* the categories the package belongs to */ 
-  Dependency *required; /* the packages required for this package to work */
-  actions action;	/* A range of states applicable to this package */
-  trusts trust;		/* Selects among info[] below, a subset of action */
-  int srcpicked;	/* True if source is required */
-
-  Info *installed;	/* Info on installed package */
-  trusts installed_ix;	/* Index into info array for currently installed package */
-  excludes exclude;	/* true if this package should be excluded */
+  char *name;			/* package name, like "cygwin" */
+  char *sdesc;			/* short description (replaces "name" if provided) */
+  char *ldesc;			/* long description (multi-line) */
+  Category *category;		/* the categories the package belongs to */
+  Dependency *required;		/* the packages required for this package to work */
+  actions action;		/* A range of states applicable to this package */
+  trusts trust;			/* Selects among info[] below, a subset of action */
+  int srcpicked;		/* True if source is required */
+
+  Info *installed;		/* Info on installed package */
+  trusts installed_ix;		/* Index into info array for currently installed package */
+  excludes exclude;		/* true if this package should be excluded */
 
   /* The reason for this weird layout is to allow for loops that scan either
      the info array, based on trust value or the infoscan array based on a pointer,
@@ -140,20 +145,22 @@ extern Category *category;
 extern int ncategories;
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
-Package *new_package (char *name);
-void	ini_init (char *string);
-Package *getpkgbyname (const char *pkgname);
-void    new_requirement (Package *package, char *dependson);
-Category *getcategorybyname (const char *categoryname);
-Category *getpackagecategorybyname (Package *pkg, const char *categoryname); 
-Category *register_category (const char *name);
-void    add_category (Package *package, Category *cat);
+  Package *new_package (char *name);
+  void ini_init (char *string);
+  Package *getpkgbyname (const char *pkgname);
+  void new_requirement (Package * package, char *dependson);
+  Category *getcategorybyname (const char *categoryname);
+  Category *getpackagecategorybyname (Package * pkg,
+				      const char *categoryname);
+  Category *register_category (const char *name);
+  void add_category (Package * package, Category * cat);
 
 #ifdef __cplusplus
 }
 #endif
 
-#endif /* _INI_H_ */
+#endif				/* _INI_H_ */
Index: inilex.l
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/inilex.l,v
retrieving revision 2.5
diff -u -p -r2.5 inilex.l
--- inilex.l	2001/09/21 17:57:52	2.5
+++ inilex.l	2001/11/11 06:54:56
@@ -27,7 +27,7 @@
 #define YY_INPUT(buf,result,max_size) { result = ini_getchar(buf, max_size); }
 
 static int ini_getchar(char *buf, int max_size);
-static void ignore_line ();
+static void ignore_line (void);
 
 %}
 
@@ -119,7 +119,7 @@ static void
 ignore_line ()
 {
   char c;
-  while (c = input ())
+  while ((c = input ()))
     {
       if (c == EOF)
 	return;
Index: install.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/install.cc,v
retrieving revision 2.21
diff -u -p -r2.21 install.cc
--- install.cc	2001/11/02 00:50:19	2.21
+++ install.cc	2001/11/11 06:54:56
@@ -17,9 +17,12 @@
    the install list (in ini.h).  Note that we use a separate thread to
    maintain the progress dialog, so we avoid the complexity of
    handling two tasks in one thread.  We also create or update all the
-   files in /etc/setup/* and create the mount points. */
+   files in /etc/setup/\* and create the mount points. */
 
-static char *cvsid = "\n%%% $Id: install.cc,v 2.21 2001/11/02 00:50:19 rbcollins Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: install.cc,v 2.21 2001/11/02 00:50:19 rbcollins Exp $\n";
+#endif
 
 #include "win32.h"
 #include "commctrl.h"
@@ -39,7 +42,6 @@ static char *cvsid = "\n%%% $Id: install
 #include "geturl.h"
 #include "mkdir.h"
 #include "state.h"
-#include "tar.h"
 #include "diskfull.h"
 #include "msg.h"
 #include "mount.h"
@@ -47,6 +49,11 @@ static char *cvsid = "\n%%% $Id: install
 #include "hash.h"
 #include "mount.h"
 #include "filemanip.h"
+#include "io_stream.h"
+#include "compress.h"
+#include "compress_gz.h"
+#include "archive.h"
+#include "tar.h"
 
 #include "port.h"
 
@@ -71,13 +78,12 @@ dialog_cmd (HWND h, int id, HWND hwndctl
     case IDCANCEL:
       exit_setup (1);
     }
+  return 0;
 }
 
 static BOOL CALLBACK
 dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
 {
-  int i, j;
-  HWND listbox;
   switch (message)
     {
     case WM_INITDIALOG:
@@ -102,19 +108,19 @@ dialog (void *)
   int rv = 0;
   MSG m;
   HWND ins_dialog = CreateDialog (hinstance, MAKEINTRESOURCE (IDD_INSTATUS),
-				   0, dialog_proc);
+				  0, dialog_proc);
   if (ins_dialog == 0)
     fatal ("create dialog");
   ShowWindow (ins_dialog, SW_SHOWNORMAL);
   UpdateWindow (ins_dialog);
-  while (GetMessage (&m, 0, 0, 0) > 0) {
-    TranslateMessage (&m);
-    DispatchMessage (&m);
-  }
+  while (GetMessage (&m, 0, 0, 0) > 0)
+    {
+      TranslateMessage (&m);
+      DispatchMessage (&m);
+    }
+  return rv;
 }
 
-static DWORD start_tics;
-
 static void
 init_dialog ()
 {
@@ -160,14 +166,13 @@ progress (int bytes)
 static void
 badrename (char *o, char *n)
 {
-  char buf[1000];
-  char *err = strerror (errno);
+  const char *err = strerror (errno);
   if (!err)
     err = "(unknown error)";
   note (IDS_ERR_RENAME, o, n, err);
 }
 
-static char *standard_dirs[] = {
+static const char *standard_dirs[] = {
   "/bin",
   "/etc",
   "/lib",
@@ -191,14 +196,14 @@ hash::add_subdirs (char *path)
 {
   char *nonp, *pp;
   for (nonp = path; *nonp == '\\' || *nonp == '/'; nonp++);
-  for (pp = path + strlen(path) - 1; pp>nonp; pp--)
+  for (pp = path + strlen (path) - 1; pp > nonp; pp--)
     if (*pp == '/' || *pp == '\\')
       {
-	int i, s=0;
+	int i, s = 0;
 	char c = *pp;
 	*pp = 0;
-	for (i=0; standard_dirs[i]; i++)
-	  if (strcmp (standard_dirs[i]+1, path) == 0)
+	for (i = 0; standard_dirs[i]; i++)
+	  if (strcmp (standard_dirs[i] + 1, path) == 0)
 	    {
 	      s = 1;
 	      break;
@@ -209,24 +214,18 @@ hash::add_subdirs (char *path)
       }
 }
 
-static int
-exists (const char *file)
-{
-  if (_access (file, 0) == 0)
-    return 1;
-  return 0;
-}
-
 static int num_installs, num_uninstalls;
 
 static void
-uninstall_one (Package *pkg, bool src)
+uninstall_one (Package * pkg, bool src)
 {
   hash dirs;
   char line[_MAX_PATH];
 
-  gzFile lst = gzopen (cygpath ("/etc/setup/", pkg->name,
-				(src ? "-src.lst.gz" : ".lst.gz"), 0), "rb");
+  io_stream *tmp =
+    io_stream::open (concat ("cygfile:///etc/setup/", pkg->name,
+			     (src ? "-src.lst.gz" : ".lst.gz"), 0), "rb");
+  io_stream *lst = compress::decompress (tmp);
   if (lst)
     {
       SetWindowText (ins_pkgname, pkg->name);
@@ -236,10 +235,10 @@ uninstall_one (Package *pkg, bool src)
       else
 	log (0, "Uninstalling old %s", pkg->name);
 
-      while (gzgets (lst, line, sizeof (line)))
+      while (lst->gets (line, sizeof (line)))
 	{
-	  if (line[strlen(line)-1] == '\n')
-	    line[strlen(line)-1] = 0;
+	  if (line[strlen (line) - 1] == '\n')
+	    line[strlen (line) - 1] = 0;
 
 	  dirs.add_subdirs (line);
 
@@ -251,7 +250,7 @@ uninstall_one (Package *pkg, bool src)
 	      DeleteFile (d);
 	    }
 	}
-      gzclose (lst);
+      delete lst;
 
       remove (cygpath ("/etc/setup/", pkg->name, ".lst.gz", 0));
 
@@ -275,45 +274,54 @@ uninstall_one (Package *pkg, bool src)
 
 
 static int
-install_one (Package *pkg, bool isSrc)
+install_one (Package * pkg, bool isSrc)
 {
   int errors = 0;
-  char *extra;
+  const char *extra;
   const char *file;
   int file_size;
+  archive *thefile = NULL;
   Info *pi = pkg->info + pkg->trust;
 
   if (!isSrc)
     {
       extra = "";
       file_size = pi->install_size;
-      file = pi->install;
+      file = concat ("file://", pi->install, 0);
     }
   else if (pi->source)
     {
       extra = "-src";
       file_size = pi->source_size;
-      file = pi->source;
+      file = concat ("file://", pi->source, 0);
     }
   else
     return 0;
 
   char name[strlen (pkg->name) + strlen (extra) + 1];
   strcat (strcpy (name, pkg->name), extra);
-  
+
+  /* FIXME: this may file now */
   char *basef = base (file);
   SetWindowText (ins_pkgname, basef);
 
-  if (!exists (file))
+  if (!io_stream::exists (file))
     file = basef;
-  if (!exists (file))
+  if (!io_stream::exists (file))
     {
       note (IDS_ERR_OPEN_READ, file, "No such file");
       return 1;
     }
 
-  gzFile lst = gzopen (cygpath ("/etc/setup/", name, ".lst.gz", 0),
-		       "wb9");
+  io_stream *tmp =
+    io_stream::open (concat ("cygfile:///etc/setup/", name, ".lst.gz", 0),
+		     "wb");
+  io_stream *lst = new compress_gz (tmp, "w9");
+  if (lst->error ())
+    {
+      delete lst;
+      lst = NULL;
+    }
 
   package_bytes = file_size;
 
@@ -342,44 +350,60 @@ install_one (Package *pkg, bool isSrc)
     case ACTION_TEST:
       strcat (msg, " test version...");
       break;
+    default:
+      /* FIXME: log this somehow */
+      break;
     }
 
   SetWindowText (ins_action, msg);
   log (0, "%s%s", msg, file);
-  tar_open (file);
-
-  char *fn;
-  while (fn = tar_next_file ())
+  tmp = io_stream::open (file, "rb");
+  if (tmp)
     {
-      char *dest_file;
+      io_stream *tmp2 = compress::decompress (tmp);
+      if (tmp2)
+	thefile = archive::extract (tmp2);
+      else
+	thefile = archive::extract (tmp);
+      /* FIXME: potential leak of either *tmp or *tmp2 */
+      if (thefile)
+	{
+	  const char *fn;
+	  while ((fn = thefile->next_file_name ()))
+	    {
+	      char *dest_file;
 
-      if (lst)
-	gzprintf (lst, "%s\n", fn);
+	      if (lst)
+		lst->write (concat (fn, "\n", 0), strlen (fn) + 1);
 
-      dest_file = cygpath (isSrc ? "/usr/src/" : "/", fn, NULL);
+	      dest_file =
+		concat ("cygfile://", isSrc ? "/usr/src/" : "/", NULL);
 
-      SetWindowText (ins_filename, dest_file);
-      log (LOG_BABBLE, "Installing file %s", dest_file);
-      if (tar_read_file (dest_file) != 0)
-	{
-	  log (0, "Unable to install file %s", dest_file);
-	  errors++;
-	}
+	      /* FIXME: concat leaks memory */
+	      SetWindowText (ins_filename, concat (dest_file, fn, 0));
+	      log (LOG_BABBLE, "Installing file %s%s", dest_file, fn);
+	      if (archive::extract_file (thefile, dest_file) != 0)
+		{
+		  log (0, "Unable to install file %s%s", dest_file, fn);
+		  errors++;
+		}
+
+	      progress (tmp->tell ());
+	      free (dest_file);
+	      num_installs++;
+	    }
+	  delete thefile;
 
-      progress (tar_ftell ());
-      free (dest_file); 
-      num_installs++;
+	  total_bytes_sofar += file_size;
+	}
     }
-  tar_close ();
-
-  total_bytes_sofar += file_size;
   progress (0);
 
   int df = diskfull (get_root_dir ());
   SendMessage (ins_diskfull, PBM_SETPOS, (WPARAM) df, 0);
 
   if (lst)
-    gzclose (lst);
+    delete lst;
 
   if (!errors)
     {
@@ -387,7 +411,9 @@ install_one (Package *pkg, bool isSrc)
       pkg->installed_ix = pkg->trust;
       if (pkg->installed)
 	free (pkg->installed);
-      pkg->installed = new Info (inf->install, inf->version, inf->install_size, inf->source, inf->source_size);
+      pkg->installed =
+	new Info (inf->install, inf->version, inf->install_size, inf->source,
+		  inf->source_size);
     }
 
   return errors;
@@ -404,22 +430,26 @@ check_for_old_cygwin ()
     return;
 
   char msg[sizeof (buf) + 132];
-  sprintf (msg, "An old version of cygwin1.dll was found here:\r\n%s\r\nDelete?", buf);
-  switch (MessageBox (NULL, msg,
-		      "What's that doing there?", MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL))
+  sprintf (msg,
+	   "An old version of cygwin1.dll was found here:\r\n%s\r\nDelete?",
+	   buf);
+  switch (MessageBox
+	  (NULL, msg, "What's that doing there?",
+	   MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL))
     {
     case IDYES:
       if (!DeleteFile (buf))
 	{
 	  sprintf (msg, "Couldn't delete file %s.\r\n"
-			"Is the DLL in use by another application?\r\n"
-			"You should delete the old version of cygwin1.dll\r\nat your earliest convenience.",
-			buf);
-	  MessageBox (NULL, buf, "Couldn't delete file", MB_OK | MB_ICONEXCLAMATION | MB_TASKMODAL);
+		   "Is the DLL in use by another application?\r\n"
+		   "You should delete the old version of cygwin1.dll\r\nat your earliest convenience.",
+		   buf);
+	  MessageBox (NULL, buf, "Couldn't delete file",
+		      MB_OK | MB_ICONEXCLAMATION | MB_TASKMODAL);
 	}
       break;
     default:
-	break;
+      break;
     }
 
   return;
@@ -437,7 +467,7 @@ do_install (HINSTANCE h)
 
   mkdir_p (1, get_root_dir ());
 
-  for (i=0; standard_dirs[i]; i++)
+  for (i = 0; standard_dirs[i]; i++)
     {
       char *p = cygpath (standard_dirs[i], 0);
       mkdir_p (1, p);
@@ -445,11 +475,8 @@ do_install (HINSTANCE h)
     }
 
   /* Create /var/run/utmp */
-  char *utmp = cygpath ("/var/run/utmp", 0);
-  FILE *ufp = fopen (utmp, "wb");
-  if (ufp)
-    fclose (ufp);
-  free (utmp);
+  io_stream *utmp = io_stream::open ("cygfile:///var/run/utmp", "wb");
+  delete utmp;
 
   dismiss_url_status_dialog ();
 
@@ -469,7 +496,7 @@ do_install (HINSTANCE h)
   create_mount ("/usr/lib", cygpath ("/lib", 0), istext, issystem);
   set_cygdrive_flags (istext, issystem);
 
-  for (Package *pkg = package; pkg->name; pkg++)
+  for (Package * pkg = package; pkg->name; pkg++)
     {
       Info *pi = pkg->info + pkg->trust;
       if (pkg->action != ACTION_SRC_ONLY)
@@ -478,7 +505,7 @@ do_install (HINSTANCE h)
 	total_bytes += pi->source_size;
     }
 
-  for (Package *pkg = package; pkg->name; pkg++)
+  for (Package * pkg = package; pkg->name; pkg++)
     {
       if (is_uninstall_action (pkg))
 	{
@@ -499,7 +526,7 @@ do_install (HINSTANCE h)
 	      errors++;
 	    }
 	}
-    } // end of big package loop
+    }				// end of big package loop
 
   ShowWindow (ins_dialog, SW_HIDE);
 
@@ -514,7 +541,7 @@ do_install (HINSTANCE h)
 
   if (!ndb)
     {
-      char *err = strerror (errno);
+      const char *err = strerror (errno);
       if (!err)
 	err = "(unknown error)";
       fatal (IDS_ERR_OPEN_WRITE, ndb, err);
@@ -523,18 +550,19 @@ do_install (HINSTANCE h)
   if (odb)
     {
       char line[1000], pkgname[1000];
-      int printit;
       while (fgets (line, 1000, odb))
 	{
 	  sscanf (line, "%s", pkgname);
 	  Package *pkg = getpkgbyname (pkgname);
-	  if (!pkg || (!is_download_action (pkg) && pkg->action != ACTION_UNINSTALL))
+	  if (!pkg
+	      || (!is_download_action (pkg)
+		  && pkg->action != ACTION_UNINSTALL))
 	    fputs (line, ndb);
 	}
 
     }
 
-  for (Package *pkg = package; pkg->name; pkg++)
+  for (Package * pkg = package; pkg->name; pkg++)
     if (is_download_action (pkg))
       {
 	Info *pi = pkg->info + pkg->installed_ix;
